<template>
    <div class="element-switch">
        <div class="element-switch__content">
            <b-form-input
                v-model="item"
                :formatter="type == 'price' ? getValueWithOneDot : getIntValue"
                @blur="checkDot"
            />
        </div>
        <div class="element-switch__actions">
            <img
                class="chevron_top"
                src="/images/chevron-down.svg"
                alt="chevron_down"
                @click="change('plus')"
            >
            <img
                class="chevron_bottom"
                src="/images/chevron-down.svg"
                alt="shevron_down"
                @click="change('minus')"
            >
        </div>
    </div>
</template>

<script>
export default {
    props: {
        type: {
            type: String,
            default: 'price'
        },
        value: null,
        step: null,
        toFixed: null,
    },
    computed: {
        item: {
            get() {
                return this.value
            },
            set(value) {
                this.save(value)
            }
        }
    },
    created() {
        this.firstLoad()
    },
    methods: {
        firstLoad() {
          if (this.value && this.value !== '0') this.item = this.value;
          this.checkDot()
        },
        checkDot() {
            if(this.type !== 'price' && parseInt(this.item) == 0 || !this.item)  {
                this.item = this.step
                return
            }
            if(this.type !== 'price') return
            
            let stringItem = String(this.item)
            const last = stringItem.length - 1
            if(stringItem.includes('.')) { 
                if(stringItem[last] == '.') stringItem = stringItem.split('.')[0]
                if(stringItem[0] == '.') {
                    const splitArray = stringItem.split('.')
                    stringItem = `0.${splitArray[1]}`
                }   
                if(stringItem.length == 3) stringItem = `${stringItem}0`
            }
            this.item = stringItem !== '0' ? stringItem : this.step
        },
        getValueWithOneDot(value) {
            const rgx = /^[0-9]*\.?[0-9]*$/
            const withoutWord = value.match(rgx)
            const item = value && withoutWord ? withoutWord?.input || this.item : ''
            let result = item
            if(item && item.includes('.')) {
                result = item.split('.')
                result[1] = result[1].substring(0, 2)
                result = result.join('.')
            }
            if(result[0] == 0 && result.length == 2 && result[1] !== '.') {
                result = result.split('').join('.')
            }
            return result
        },
        change(type) {
            let current
            if(this.type == 'price') current = this.item !== '' ? parseFloat(this.item) : this.step;
            else if(this.type == 'int') current = this.item !== '' ? parseInt(this.item) : this.step;
            let value
            if(this.type == 'price') {
                if (type == "plus") value = current + parseFloat(this.step);
                else value = current - parseFloat(this.step);
            } else if(this.type == 'int') {
                if (type == "plus") value = current + parseInt(this.step);
                else value = current - parseInt(this.step);
            }
            if (value <= 0) value = this.step;
            this.item = this.type == 'price' ? value.toFixed(2) : value;
        },
        getIntValue(value) {
            const item = value.replace(/\D+/g,"")
            if(item.length > 4) return this.item
            return item ? parseInt(item) : ''
        },
        save(value) {
            this.$emit('input', value)
        }
    }
}
</script>

<style lang="scss" scoped>
.element-switch {
    width: 100%;
    margin-right: 11px;
    font-weight: 500;
    font-size: 14px;
    line-height: 16px;
}
.form-control {
  padding: 0;
  font-weight: 500;
  border: none;
  &:focus,
  &:active {
    outline: 0;
    box-shadow: none;
  }
}

</style>
